# Cmput 455 sample code
# Sampling from a Bernoulli distribution
# Written by Martin Mueller

import random

def bernoulliExperiment(p):
    # int(boolean): int(True) = 1, int(False) = 0
    return int(random.random() < p)

def bernoulliSample(p, limit):
    print("\nRepeated Bernoulli experiment for {:f}, {} iterations".format(p, limit))
    nextPrintTime = 1
    wins = 0
    for n in range(limit):
        if n >= nextPrintTime:
            print("After {} simulations, estimate of {:f} = {:f}"
                  .format(n, p, wins / n))
            nextPrintTime *= 2
        wins += bernoulliExperiment(p)
    return wins / limit

if __name__ == "__main__":
    random.seed()
    bernoulliSample(0.5, 1000000)
    bernoulliSample(0.1, 1000000)
    bernoulliSample(0.9999, 1000000)
    bernoulliSample(0.00001, 1000000)
